Attribute VB_Name = "modPublicItems"
Option Explicit

Public Playback As Long

Public GameState As Long              'current state of game
Public Const MaxSlots As Long = 15
Public Pins(MaxSlots) As Long         'set to 1 if pin holes are filled
Public Replay As Boolean              'true if the user wants to replay the history
Public ReplayPause As Long            'replay pausing
Public RunDemo As Boolean
Public SliderCount As Long            'random challenge countdown

Public GameWon As Boolean             'if the user won the game
Public GameOver As Boolean            'if the game is over
Public HaveSaved As Boolean           'if game info has been saved
Public HadFinished As Boolean         'if the player had the game finish for them
Public UsedHints As Long              'track number of hints used
Public UndoCnt As Long                'number of time the user did an undo

Public RandomMadness As Boolean       'true if random madness running
Public MadnessTimer As Long           '# seconds for each game
Public MadnessPins(MaxSlots) As Long  'random maddness pin start map
Public MadnessGames As Long           'number of madness games left

Public PlayerName As String           'current player name
Public SelectedPlayer As String
Public colPlayers As Collection       'collection of players

Public Grid(MaxSlots, 1, 3) As Long    'jumping guide
Public lclPins(MaxSlots) As Long       'temp storage for hint tracking
Public Clrz(MaxSlots) As Long          'colors of pin hole
Public ClrJ(MaxSlots) As Long          'color of jumped item
Public ClrO(MaxSlots) As Long          'original Colors for replay
Public NewGame As Boolean              'if it is a new game
Public JumpingPin As Long              'pin used for jumping
Public ImgChanged As Long              'if pin hole image is different than normal
Public RandomGame As Boolean           'when Random Challenge game running

Public SingleStep As Boolean           'single-step support
Public PlayState As Long

Public colHistory As Collection        'user move history

Public Const NumMbl As Long = 5

Public Const BlkMbl As Long = 1
Public Const BluMbl As Long = 2
Public Const RedMbl As Long = 3
Public Const WhtMbl As Long = 4
Public Const YloMbl As Long = 5
Public Const GrnMbl As Long = 6

Public Const NmlMbl As Long = 1
Public Const JmpMbl As Long = 2
Public Const InvMbl As Long = 3
Public Const ValMbl As Long = 4

'*******************************************************************************
' Function Name     : GetUsrName
' Purpose           : Derive usr name from proper name
'*******************************************************************************
Public Function GetUsrName(uName As String) As String
  Dim cNm As String
  Dim i As Long
  
  cNm = vbNullString
  For i = 1 To Len(uName)
    Select Case LCase$(Mid$(uName, i, 1))     'keep only a-z
      Case "a" To "z"
        cNm = cNm & LCase$(Mid$(uName, i, 1)) 'all lowercase
    End Select
  Next i
  GetUsrName = cNm
End Function

'*******************************************************************************
' Subroutine Name   : SetPause
' Purpose           : Set Replay Pause message text
'*******************************************************************************
Public Sub SetPause()
  Dim S As String
  
  Select Case ReplayPause / 4   '1 Replaypause = 1/8 sec. Set in 1/2 sec intervals (*4)
    Case 0
      S = "0 seconds"
    Case 1
      S = "0.5 second"
    Case 2
      S = "1.0 second"
    Case 3
      S = "1.5 seconds"
    Case 4
      S = "2.0 seconds"
    Case 5
      S = "2.5 seconds"
    Case 6
      S = "3.0 seconds"
    Case 7
      S = "3.5 seconds"
    Case 8
      S = "4.0 seconds"
  End Select
  frmJumpAllButOne.mnuReplayPause.Caption = "Replay &pause = " & S & "..."
End Sub

'*******************************************************************************
' Subroutine Name   : InitPinO
' Purpose           : Support for replaying database-saved games
'*******************************************************************************
Public Sub InitPinO()
  Dim Pin As Long
  
  For Pin = 1 To MaxSlots
    ClrO(Pin) = Fix(5! * Rnd() + 2)
    frmJumpAllButOne.Image1(Pin).Picture = frmJumpAllButOne.ButtonList.ListImages((Clrz(Pin) - 1) * 4 + 1).Picture
  Next Pin
End Sub

'*******************************************************************************
' Function Name     : GetPinCount
' Purpose           : Get number of pins still in board
'*******************************************************************************
Public Function GetPinCount() As Long
  Dim Idx As Long, Cnt As Long
  
  For Idx = 1 To MaxSlots
    Cnt = Cnt + Pins(Idx)
  Next Idx
  GetPinCount = Cnt
End Function

